package cn.iocoder.yudao.module.erp.service.mold;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.mock.mockito.MockBean;


import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.common.controller.admin.mold.vo.*;
import cn.iocoder.yudao.module.common.dal.dataobject.mold.MoldBrandDO;
import cn.iocoder.yudao.module.common.dal.mysql.mold.MoldBrandMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.erp.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link MoldBrandServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(MoldBrandServiceImpl.class)
public class MoldBrandServiceImplTest extends BaseDbUnitTest {

    @Resource
    private MoldBrandServiceImpl moldBrandService;

    @Resource
    private MoldBrandMapper moldBrandMapper;

    @Test
    public void testCreateMoldBrand_success() {
        // 准备参数
        MoldBrandSaveReqVO createReqVO = randomPojo(MoldBrandSaveReqVO.class).setId(null);

        // 调用
        Long moldBrandId = moldBrandService.createMoldBrand(createReqVO);
        // 断言
        assertNotNull(moldBrandId);
        // 校验记录的属性是否正确
        MoldBrandDO moldBrand = moldBrandMapper.selectById(moldBrandId);
        assertPojoEquals(createReqVO, moldBrand, "id");
    }

    @Test
    public void testUpdateMoldBrand_success() {
        // mock 数据
        MoldBrandDO dbMoldBrand = randomPojo(MoldBrandDO.class);
        moldBrandMapper.insert(dbMoldBrand);// @Sql: 先插入出一条存在的数据
        // 准备参数
        MoldBrandSaveReqVO updateReqVO = randomPojo(MoldBrandSaveReqVO.class, o -> {
            o.setId(dbMoldBrand.getId()); // 设置更新的 ID
        });

        // 调用
        moldBrandService.updateMoldBrand(updateReqVO);
        // 校验是否更新正确
        MoldBrandDO moldBrand = moldBrandMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, moldBrand);
    }

    @Test
    public void testUpdateMoldBrand_notExists() {
        // 准备参数
        MoldBrandSaveReqVO updateReqVO = randomPojo(MoldBrandSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> moldBrandService.updateMoldBrand(updateReqVO), MOLD_BRAND_NOT_EXISTS);
    }

    @Test
    public void testDeleteMoldBrand_success() {
        // mock 数据
        MoldBrandDO dbMoldBrand = randomPojo(MoldBrandDO.class);
        moldBrandMapper.insert(dbMoldBrand);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbMoldBrand.getId();

        // 调用
        moldBrandService.deleteMoldBrand(id);
       // 校验数据不存在了
       assertNull(moldBrandMapper.selectById(id));
    }

    @Test
    public void testDeleteMoldBrand_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> moldBrandService.deleteMoldBrand(id), MOLD_BRAND_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetMoldBrandPage() {
       // mock 数据
       MoldBrandDO dbMoldBrand = randomPojo(MoldBrandDO.class, o -> { // 等会查询到
           o.setCode(null);
           o.setName(null);
           o.setMoldType(null);
           o.setProductId(null);
           o.setUseTime(null);
           o.setMaintainType(null);
           o.setMaintainTime(null);
           o.setMoldSize(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       moldBrandMapper.insert(dbMoldBrand);
       // 测试 code 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setCode(null)));
       // 测试 name 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setName(null)));
       // 测试 moldType 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setMoldType(null)));
       // 测试 productId 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setProductId(null)));
       // 测试 useTime 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setUseTime(null)));
       // 测试 maintainType 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setMaintainType(null)));
       // 测试 maintainTime 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setMaintainTime(null)));
       // 测试 moldSize 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setMoldSize(null)));
       // 测试 remark 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       moldBrandMapper.insert(cloneIgnoreId(dbMoldBrand, o -> o.setCreateTime(null)));
       // 准备参数
       MoldBrandPageReqVO reqVO = new MoldBrandPageReqVO();
       reqVO.setCode(null);
       reqVO.setName(null);
       reqVO.setMoldType(null);
       reqVO.setProductId(null);
       reqVO.setMaintainType(null);
       reqVO.setMoldSize(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<MoldBrandRespVO> pageResult = moldBrandService.getMoldBrandPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbMoldBrand, pageResult.getList().get(0));
    }

}